/**
* This code was generated by v0 by Vercel.
* @see https://v0.dev/t/gur0C4inpuL
* Documentation: https://v0.dev/docs#integrating-generated-code-into-your-nextjs-app
*/

/** Add fonts into your Next.js project:

import { Inter } from 'next/font/google'

inter({
  subsets: ['latin'],
  display: 'swap',
})

To read more about using these font, please visit the Next.js documentation:
- App Directory: https://nextjs.org/docs/app/building-your-application/optimizing/fonts
- Pages Directory: https://nextjs.org/docs/pages/building-your-application/optimizing/fonts
**/
import { Dialog, DialogContent, DialogHeader, DialogTitle, DialogDescription } from "@/components/ui/dialog"
import { Button, buttonVariants } from "@/components/ui/button"
import { Input } from "@/components/ui/input"
import { Label } from "@/components/ui/label"
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'
import { faDownload } from "@fortawesome/free-solid-svg-icons"
import { useEffect, useState } from "react"
import { toast } from "react-toastify"
import { Loader2 } from "lucide-react"
import { cn } from "@/lib/utils"
import { User } from "@/lib/api"
import { CopyToClipboardButton } from "./copy-to-clipboard-button"
import { Checkbox } from "./ui/checkbox"
import { base64_encode_bytes } from "@/lib/base64"

export function generate_password_file_name(user: User | null) {
	// TODO test if the username in the file could cause a security issue (XSS or similar).
	// I think this should be secure.
	return "e2e_passwort_" + user?.username + "@" + window.location.hostname + ".txt"
}

export function KeyGeneratorDialog({
	open,
	justLoggedIn,
	hasKeys,
	user,
	onCancel,
	onCreateRequest,
	onError,
}: {
	open: boolean,
	justLoggedIn: boolean,
	hasKeys: boolean,
	user: User | null,
	onCancel: () => void,
	onCreateRequest: (password: string) => Promise<void>,
	onError: (error: unknown) => void,
}) {

	const [password, setPassword] = useState(null as string | null);
	const [passwordFileName, setPasswordFileName] = useState(null as string | null);
	const [passwordFileURL, setPasswordFileURL] = useState(null as string | null);
	const [creating, setCreating] = useState(false);
	const [confirmed, setConfirmed] = useState(false);

	useEffect(() => {
		setPasswordFileURL((old) => {
			if (old) {
				URL.revokeObjectURL(old);
			}
			if (!password) {
				return null;
			} else {
				const lines = [
					password,
					"^^^ GEHEIMES E2E SCHLÜSSEL PASSWORT ^^^",
					"Art: Ende-zu-Ende Schlüssel Passwort",
					"Nutzer: " + user?.username.toString(),
					"Domain: https://" + window.location.hostname,
					"Erstellungszeitpunkt: " + new Date().toISOString(),
					"Beschreibung:",
					"    Diese Datei beinhaltet das Passwort für deinen Ende-zu-Ende Schlüssel in der ersten Zeile.",
					"    Sie wurde automatisch generiert als du deinen Ende-zu-Ende Schlüssel erstellt hast.",
					"    Beim Anmelden auf der Webseite kannst du diese Datei hochladen um deinen Ende-zu-Ende Schlüssel zu entsperren.",
					"    Bitte verändere diese Datei nicht!",
					"    Bitte teile diese Datei mit niemandem!",
					"    Bitte bewahre diese Datei gut und sicher auf!",
					"    Bitte erstelle sichere Backups dieser Datei!",
					"",
				];
				return URL.createObjectURL(new Blob([lines.join("\r\n")], { type: "text/plain" }));
			}
		});
		setPasswordFileName(generate_password_file_name(user));
	}, [password, user])

	useEffect(() => {
		if (!open) {
			// delete password when the dialog closes
			setPassword(null);
			setConfirmed(false);
		} else {
			// generate new random password
			setPassword(base64_encode_bytes(crypto.getRandomValues(new Uint8Array(32))).replaceAll("/", "s").replaceAll("+", "p").replaceAll("=", ""));
		}
		setCreating(false);
	}, [open]);

	return (
		<Dialog open={open} modal={true} onOpenChange={(open) => {
			if (!open) {
				onCancel();
			}
		}}>
			<DialogContent className="sm:max-w-[500px]">
				<DialogHeader>
					<DialogTitle>Ende-zu-Ende Schlüssel Erstellen</DialogTitle>
					<DialogDescription>
						{!hasKeys ? <span>
							Du hast auf diesem Account zur Zeit keine Schlüssel für die sichere Kommunikation.
							Es muss deshalb ein neuer Schlüssel erstellt werden.
						</span> : null}
						Dieser Schlüssel wird mit einem Passwort gesichert, welches du unten einsehen und herunterladen kannst.
						Du musst dieses Passwort bei jeder Anmeldung angeben, um Zugriff auf deine Nachrichten zu bekommen. <strong>Pass also gut drauf auf!</strong>
					</DialogDescription>
				</DialogHeader>
				<div className="grid gap-4 py-4">
					{password && passwordFileURL && passwordFileName ?
						<div className="grid grid-cols-[1fr_auto_auto] items-center gap-4">
							<div className="grid gap-2">
								<Label htmlFor="password">Passwort kopieren</Label>
								<div className="flex">
									<Input id="password" type="text" className="font-mono"
										readOnly
										value={password}
									/>
									<CopyToClipboardButton data={password} onSuccess={() => {
										toast.info("Copied to clipboard.");
									}} />
								</div>
							</div>
							<span>oder</span>
							<div className="grid gap-2">
								<a href={passwordFileURL}
									download={passwordFileName}
									className={cn(buttonVariants())}
								>
									<FontAwesomeIcon icon={faDownload} className="pr-2" />
									<span>Herunterladen</span>
								</a>
							</div>
						</div>
						: <p>
							<Loader2 className="mr-2 h-4 w-4 animate-spin inline" />
							Generiere Passwort...
						</p>}
					<div className="flex items-center space-x-2">
						<Checkbox id="confirmation"
							checked={confirmed}
							disabled={creating}
							onCheckedChange={(checked) => {
								setConfirmed(checked.valueOf() as boolean);
							}}
						/>
						<label
							htmlFor="confirmation"
							className="text-sm font-medium leading-none peer-disabled:cursor-not-allowed peer-disabled:opacity-70"
						>
							Ich versichere, dass ich das Passwort <strong>an einem sicheren Ort gespeichert</strong> habe.
						</label>
					</div>

					<div className="flex gap-2">
						<Button variant="outline" type="button" onClick={() => { onCancel() }}>{justLoggedIn ? "Später" : "Abbrechen"}</Button>
						<Button className="ml-auto" type="button" disabled={!(password && confirmed && !creating)} onClick={() => {
							if (!(password && confirmed)) {
								return;
							}
							setCreating(true);
							onCreateRequest(password).then(
								() => {
									setPassword(null);
									setConfirmed(false);
								}
							).catch(onError).finally(() => {
								setCreating(false);
							});
						}}>
							{creating ? <Loader2 className="mr-2 h-4 w-4 animate-spin inline" /> : null}
							<span>Schlüssel erstellen</span>
						</Button>
					</div>
					<p className="text-sm text-muted-foreground">
						Alle Formulare sind grundsätzlich Ende-zu-Ende verschlüsselt.
					</p>
					{hasKeys ? <p className="text-sm text-muted-foreground">
						Du wirst nur neue Nachrichten mit diesem neuen Schlüssel einsehen können.
						Bei älteren Nachrichten muss sich erst ein anderer Nutzer oder du mit einem anderen Schlüssel anmelden, bevor diese mit diesem neuen Schlüssel einsehbar werden.
					</p> : null}
				</div>
			</DialogContent>
		</Dialog>
	)


	/*
	return (
		<Dialog open={open} modal={true} >
			<DialogContent className="sm:max-w-[500px]"
				onEscapeKeyDown={(event) => { event.preventDefault(); onCloseRequest() }}
				onPointerDownOutside={(event) => { event.preventDefault(); onCloseRequest() }}
				onInteractOutside={(event) => { event.preventDefault(); onCloseRequest() }}
			>
				<DialogHeader>
					<DialogTitle>Generate New Encryption Key</DialogTitle>
					<DialogDescription>
						Your encryption key is essential for securing your data. Keep it safe and secure to protect your
						information.
					</DialogDescription>
				</DialogHeader>
				<div className="grid gap-4 py-4">
					<div className="flex items-center gap-4">
						<Input readOnly value="8a3b2c1d-e4f5-6g7h-8i9j-k0l1m2n3o4p" className="flex-1 font-mono" />
						<Button>
							<FontAwesomeIcon icon={faDownload} />
							Download Key
						</Button>
					</div>
				</div>
			</DialogContent>
		</Dialog>
	)
	*/
}

